#include "CThingList.h"


CThingList::CThingList()
{
   m_i_counter = 0; 

}

CThingList::~CThingList()
{
    //clear everything
    for (CThingItor itor=m_object_list.begin(); itor != m_object_list.end(); ++itor)
    {
        delete (*itor);
    }


}


void CThingList::Draw()
{
     for (CThingItor itor=m_object_list.begin(); itor != m_object_list.end(); ++itor)
    {
       if (!(*itor)->GetDeleteRequest())
       (*itor)->Draw();
    }

}

void CThingList::Think()
{
     for (CThingItor itor=m_object_list.begin(); itor != m_object_list.end(); ++itor)
    {
         if (!(*itor)->GetDeleteRequest())
         (*itor)->Think();
    }

}


void CThingList::SendMessage(int i_message, void *p_struct) //struct isn't used yet
{
    //notice we go through in reverse order, this way forward most sprites get to process
    //hits first.
    
    for (ListCThing::reverse_iterator itor=m_object_list.rbegin(); itor != m_object_list.rend(); ++itor)
    {
         if (!(*itor)->GetDeleteRequest())
         (*itor)->ProcessMessage(i_message, p_struct);
    }

}


void CThingList::ProcessDeleteRequests()
{
     for (CThingItor itor=m_object_list.begin(); itor != m_object_list.end();)
    {
         if ((*itor)->GetDeleteRequest())
         {
             delete (*itor); //delete the object
             itor = m_object_list.erase(itor);  //actually remove it from our list
         }
    
         //if we got here, no removal was done.
         itor++;
     }

}

//Note:  this method is the only way this will work with dinkumware's MSVC6 STL even with the latest
//service pack I guess.??  Grr!

template<> bool 
std::greater<CThing*>::operator()(CThing* const &x, CThing* const &y) const
{
  return x->GetSort() < y->GetSort();  //don't worry, these will get inlined
} 
 


void CThingList::ProcessSortRequests()
{
    m_object_list.sort(std::greater<CThing*>());
}


int CThingList::AddThing(CThing *p_new)
{
  //let's insert this
  int i_index = m_i_counter++;
  p_new->SetIndex(i_index);
  m_object_list.push_back(p_new);
  return i_index;

}