#include "CThingLogic.h"
#include "CGlobals.h"
#include "CThingSprite.h"
#include "CThingSheep.h"
#include "CThingMud.h"    
#include "CThingSprite.h"

//this started off really organized and nice but later turned kind of crap happy.  Sorry!

CThingLogic::CThingLogic()
{
    m_i_max_combo = 0;
    SetName("Game Logic");
    SetSort(2000); //(happen last)
    m_f_speed_mod = 2; //lowest speed
   //create first mud
    CThingMud *p_mud = new CThingMud();
    glo.m_p_thing_list->AddThing(p_mud);

    m_i_score = 0;
    m_i_lives_left = 3;
    m_i_level = 1;
    m_i_mud = 3;
    m_i_next_extra_life = C_EXTRA_LIFE_POINTS;
    m_i_game_mode = C_MODE_PAUSE;
    m_i_max_mud_balls = 5;
    m_i_mud  = m_i_max_mud_balls;
    ClearCombo();

}


void CThingLogic::ProcessMessage(int i_message, void *p_struct) //handle global messages
{

    if (i_message == C_MESSAGE_LEFT_CLICK)
    {
        if (m_i_game_mode == C_MODE_PAUSE)
        {
            //CDX bug, this causes a memory leak... we have to delete the whole object
            //glo.m_p_bg->SetImage("bg.jpg", true);
            glo.m_p_bg->SetDeleteRequest(true);


            //also create new background
            CThingSprite * p_sprite = new CThingSprite();
            glo.m_p_thing_list->AddThing(p_sprite);
            p_sprite->SetName("Background");
            p_sprite->SetImage("bg.jpg", false);
            p_sprite->SetSort(5); //under everything else
            glo.m_p_bg = p_sprite; //remember this for later...

            Reset();
          }

    }

}

void CThingLogic::ShowUpgradeScreen()
{
    m_i_game_mode = C_MODE_PAUSE;
    
    glo.m_p_bg->SetDeleteRequest(true);
    //also create new background
    CThingSprite * p_sprite = new CThingSprite();
    glo.m_p_thing_list->AddThing(p_sprite);
    p_sprite->SetName("Background");
    p_sprite->SetImage("power_up.jpg", false);
    p_sprite->SetSort(1000); //under everything else
    glo.m_p_bg = p_sprite; //remember this for later...
    m_i_max_mud_balls += 5;
    m_i_mud  = m_i_max_mud_balls;
    
}


void CThingLogic::GotHit()
{
    
    if (m_i_last_hit_time+C_COMBO_TIME_NEEDED < timeGetTime())
    {
      //  CDXLOG("Clearing combo");
        ClearCombo();
        m_i_cur_combo_count++;
    
    } else
    {
        m_i_cur_combo_count++;
        
        if (m_i_cur_combo_count > 2)
        {
            
            //award points
            ModScore(10* (m_i_cur_combo_count * m_i_cur_combo_count));

            //show combo thingie
            
            m_sound.Load(glo.m_p_sound, "combo.wav");
            m_sound.Play();
            
            CThingSprite * p_sprite = new CThingSprite();
            glo.m_p_thing_list->AddThing(p_sprite);
            //p_sprite->SetText("Get Ready For Action!");
            p_sprite->SetImage("combo.bmp", true);
            p_sprite->SetPosition(100+random(500),60+random(200));
            p_sprite->SetSpecial(C_THING_SPRITE_BOUNCE_AND_DIE);
        
            if (m_i_cur_combo_count > m_i_max_combo)
            {
                m_i_max_combo = m_i_cur_combo_count;
                
            }
            

        }
        
    }

    //either way:
    m_i_last_hit_time = timeGetTime();

}

void CThingLogic::ClearCombo()
{
    m_i_cur_combo_count = 0;
}


void CThingLogic::Reset()
{
    //start the game play mode

    m_i_game_mode = C_MODE_GET_READY;
    m_timer_main.set_interval(2300);
    //m_timer_main.set_interval(1);
    m_b_spawn_active = true;
    //show get ready message
   m_sound.Load(glo.m_p_sound, "get_ready.wav");
   m_sound.Play();
   ClearCombo();

    CThingSprite * p_sprite = new CThingSprite();
    glo.m_p_thing_list->AddThing(p_sprite);
    //p_sprite->SetText("Get Ready For Action!");
    p_sprite->SetImage("get_ready.bmp", true);
    p_sprite->SetPosition(240,240);
    p_sprite->SetSpecial(C_THING_SPRITE_BOUNCE_AND_DIE);

}

void CThingLogic::DoGetReady()
{
    //let's show the get ready message

   if (m_timer_main.interval_reached())
   {
       //start playing now
       m_i_game_mode = C_MODE_PLAY;
       m_timer_main.set_interval(15000);   //play for a while
       m_timer_spawn.set_interval(100);
   }

}

void CThingLogic::DoPlay()
{

    if (m_timer_spawn.interval_reached())
    {
        //spawn another guy
        CThingSheep * p_sheep = new CThingSheep();
        glo.m_p_thing_list->AddThing(p_sheep);
        m_timer_spawn.set_interval(random_range(C_SPAWN_MIN*m_f_speed_mod, C_SPAWN_MAX*m_f_speed_mod));
   }

  if (m_timer_main.interval_reached())
   {
       //show end of round thingie
      m_b_spawn_active = false;
      m_timer_main.set_interval(3000);
      m_i_game_mode = C_MODE_WAIT_FOR_END;
   }

}

void CThingLogic::ResetWholeGame()
{
     m_i_score = 0;
    m_i_lives_left = 3;
    m_i_level = 1;
    m_f_speed_mod = 2; //lowest speed
    m_i_next_extra_life = C_EXTRA_LIFE_POINTS;

    m_i_game_mode = C_MODE_PAUSE;
    glo.m_p_bg->SetDeleteRequest(true);
    //also create new background
    CThingSprite * p_sprite = new CThingSprite();
    glo.m_p_thing_list->AddThing(p_sprite);
    p_sprite->SetName("Background");
    p_sprite->SetImage("title_screen.jpg", false);
    p_sprite->SetSort(40000); //under everything else
    glo.m_p_bg = p_sprite; //remember this for later...
    
    m_i_max_mud_balls = 5;
    m_i_mud  = m_i_max_mud_balls;
 
}


void CThingLogic::Think()
{

//do it
    if (m_i_game_mode == C_MODE_GAME_OVER)
    {
        if (m_timer_main.interval_reached())
        {
            ResetWholeGame();
        }
    }
    
    if (m_i_game_mode == C_MODE_GET_READY)  DoGetReady();
    if (m_i_game_mode == C_MODE_PLAY)  DoPlay();
  
    //im too lazy to give everything its own function.. blah
    
    if (m_i_game_mode == C_MODE_WAIT_FOR_END)
    {
        if (m_timer_main.interval_reached())
        {
            m_i_game_mode = C_MODE_SHOW_END;
            //show some ending stuff
              m_timer_main.set_interval(2300);
            //show get ready message
              int i_rand = random_range(1, 3);
              if (i_rand == 1) m_sound.Load(glo.m_p_sound, "yeah.wav");
              if (i_rand == 2) m_sound.Load(glo.m_p_sound, "nice.wav");
              if (i_rand == 3) m_sound.Load(glo.m_p_sound, "good_work.wav");
             
             m_sound.Play();
  
            CThingSprite * p_sprite = new CThingSprite();
            glo.m_p_thing_list->AddThing(p_sprite);
            //p_sprite->SetText("Get Ready For Action!");
            p_sprite->SetImage("great.bmp", true);
            p_sprite->SetPosition(240,240);
            p_sprite->SetSpecial(C_THING_SPRITE_BOUNCE_AND_DIE);

        }
    }

   

    if (m_i_game_mode == C_MODE_SHOW_END)
    {
        if (m_timer_main.interval_reached())
        {
            m_i_level += 1;
            
            
            if (m_i_level < 3)
            {
                m_f_speed_mod -= (m_f_speed_mod / 3);
            } else
            {
                if (m_i_level < 8)
                {
                    m_f_speed_mod -= (m_f_speed_mod / 7);
                }  else
                {
                    
                    m_f_speed_mod -= (m_f_speed_mod / 10);
                }
            }
            
            if ( (m_i_level == 3) || (m_i_level == 6) || (m_i_level == 10) || (m_i_level == 15))
            {
                ShowUpgradeScreen();

            } else
            {
               Reset();
            }
        }
        
    }

}

void CThingLogic::SetupGameOver()
{
            
            CThingSprite * p_sprite = new CThingSprite();
            glo.m_p_thing_list->AddThing(p_sprite);
            //p_sprite->SetText("Get Ready For Action!");
            p_sprite->SetImage("game_over.bmp", true);
            p_sprite->SetPosition(240,240);
            p_sprite->SetSpecial(C_THING_SPRITE_BOUNCE_AND_DIE);
            m_i_game_mode = C_MODE_GAME_OVER;
            p_sprite->SetKillTimer(8000);
            m_timer_main.set_interval(8500);

}

void CThingLogic::ModScore(int i_mod)
{
    if (m_i_game_mode != C_MODE_GAME_OVER)
    {
        
        m_i_score += i_mod;
        if (m_i_score < 0) m_i_score = 0;
    }

    if (m_i_score >= m_i_next_extra_life)
    {
        m_i_next_extra_life += C_EXTRA_LIFE_POINTS;
        m_i_lives_left += 1;

        //show a graphic
        CThingSprite * p_sprite = new CThingSprite();
        glo.m_p_thing_list->AddThing(p_sprite);
        p_sprite->SetImage("extra_life.bmp", true);
        p_sprite->SetPosition(50,600);
        p_sprite->SetKillTimer(5000);
        p_sprite->SetDirection(3.14f);
        p_sprite->SetVelocity(300);
        
        
        
    }
    
}
void CThingLogic::ModLives(int i_mod)
{
    m_i_lives_left += i_mod;

    if (m_i_lives_left < 1)
    {
        m_i_lives_left = 0;
        SetupGameOver();
    }

}
void CThingLogic::ModMud(int i_mod)
{
    m_i_mud += i_mod;

    if (m_i_mud < 0) m_i_mud = 0;
    if (m_i_mud > m_i_max_mud_balls) m_i_mud = m_i_max_mud_balls; //limiting factor
}


void CThingLogic::Draw()
{
   //draw status
    int i_x = 180;
    int i_y = 5;

    
    char str[256]; 
    sprintf(str, "Score: %d    Mud In Hand: %d       Lives Left: %d       Level: %d         Max Combo So Far: %d", m_i_score,
        m_i_mud, m_i_lives_left, m_i_level, m_i_max_combo);        // Write formatted data to a string. 
    glo.m_Screen->GetBack()->GetDC(); 
    glo.m_Screen->GetBack()->SetFont(); 


    glo.m_Screen->GetBack()->TextXY(i_x+1 , i_y+1, RGB(0,0,0), str); // TextXY(x, y, color, string)
    glo.m_Screen->GetBack()->TextXY(i_x-1 , i_y-1, RGB(0,0,0), str); // TextXY(x, y, color, string)
  

    glo.m_Screen->GetBack()->TextXY(i_x-1 , i_y, RGB(0,0,0), str); // TextXY(x, y, color, string)
    glo.m_Screen->GetBack()->TextXY(i_x+1 , i_y, RGB(0,0,0), str); // TextXY(x, y, color, string)

    glo.m_Screen->GetBack()->TextXY(i_x , i_y+1, RGB(0,0,0), str); // TextXY(x, y, color, string)
    glo.m_Screen->GetBack()->TextXY(i_x , i_y-1, RGB(0,0,0), str); // TextXY(x, y, color, string)

    glo.m_Screen->GetBack()->TextXY(i_x , i_y, RGB(255,255,255), str); // TextXY(x, y, color, string)
  
    glo.m_Screen->GetBack()->ReleaseDC();
 

}


