#pragma once

#include "CThing.h"
#include "CTimer.h"

const int C_MODE_GET_READY = 0;
const int C_MODE_PLAY = 1;
const int C_MODE_ROUND_OVER = 2;
const int C_MODE_WAIT_FOR_END = 3;
const int C_MODE_SHOW_END = 4;
const int C_MODE_GAME_OVER = 5;
const int C_MODE_PAUSE = 6; //use for the title screen and stuff

const int C_SPAWN_MIN = 500;
const int C_SPAWN_MAX = 1500;

const int C_EXTRA_LIFE_POINTS = 1000;

const int C_COMBO_TIME_NEEDED = 1000;

class CThingLogic : public CThing
{
public:
    CThingLogic();
    void Reset();
    virtual void Think();
    virtual void Draw();
    void DoGetReady();
    void DoPlay();
    void ModScore(int i_mod);
    void ModLives(int i_mod);
    void ModMud(int i_mud);
    int GetMud(){return m_i_mud;}
    bool GetSpawnActive(){return m_b_spawn_active;}
    void GotHit(); //compute combos
    void ClearCombo(); //something broke the combo
    void SetupGameOver();            
    void ResetWholeGame();
    virtual void ProcessMessage(int i_message, void *p_struct); //handle global messages
    int GetGameMode(){return m_i_game_mode;}
    void ShowUpgradeScreen();    
        
private:
    
    CTimer m_timer_main; //wait for stuff like titles to show
    int m_i_game_mode;
    float m_f_speed_mod;
    CTimer m_timer_spawn;
    CDXSoundBuffer m_sound;
    
    int m_i_score;
    int m_i_lives_left;
    int m_i_level;
    int m_i_mud;
    bool m_b_spawn_active;
    int m_i_last_hit_time;
    int m_i_cur_combo_count;
    int m_i_max_combo;
    int m_i_next_extra_life;
    int m_i_max_mud_balls;
    
};