// source.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "CGlobals.h"
#include "CThingSprite.h"
#include "CThingList.h"
#include "CThingMouse.h"
#include "CThingLogic.h"
#include "CSoundPlayer.h"

char szAppName[] = "Bathroom Teacher";             // Name that will show up in the title of the app
char szClassName[] = "Bathroom Teacher";

bool g_b_show_fps = false;

double angle = 0;
                       
int frames = 0;

BOOL cdx_Init()
{ 
     switch_to_current_dir();
     srand( (unsigned)GetTickCount() );

     CDXLOGTYPE(CDXLOG_TYPE_DEBUGWIN);
      glo.m_Screen = new CDXScreen();                  // Create the CDXScreen object
    if (glo.m_Screen==NULL) return FALSE;            // If it failed return FALSE
      
 glo.m_Screen->CreateFullScreen(glo.m_hWnd, 800, 600, 16, false);

  //use this instead of you want to play windowed
  //glo.m_Screen->CreateWindowed(glo.m_hWnd, 800, 600);
   
  glo.m_p_sound->Create(glo.m_hWnd);
  g_sound_player.InitSounds();
  //create some junk
  
  CThingSprite *p_sprite = NULL;

  glo.m_p_input->Create(glo.m_hInst, glo.m_hWnd);
  
      //create background
  p_sprite = new CThingSprite();
  glo.m_p_thing_list->AddThing(p_sprite);
  p_sprite->SetName("Background");
  p_sprite->SetImage("title_screen.jpg", false);
  p_sprite->SetSort(40000); //over everything

  glo.m_p_bg = p_sprite; //remember this for later...

  //make the mouse pointer
  CThingMouse *p_mouse =  new CThingMouse();
  glo.m_p_thing_list->AddThing(p_mouse);
  glo.p_mouse = p_mouse;

  CThingLogic *p_logic = new CThingLogic();
  glo.m_p_thing_list->AddThing(p_logic);
  glo.p_logic = p_logic;

  ShowCursor(false);
  SetCapture(glo.m_hWnd);

  glo.p_hack_sprite = new CDXSprite();

  if (!glo.p_hack_sprite->Create(glo.m_Screen,"twopixels.bmp",1,1,1))
  {
      CDXLOG("Error loading the pixel hack");
      return false;
  }
  

  return TRUE; 
}

void cdx_DeInit() 
{
    SAFEDELETE(glo.p_hack_sprite);
    SAFEDELETE(glo.m_p_thing_list); //delete and remove all objects
    SAFEDELETE(glo.m_Screen); // This always needs to be destroyed last
}

void cdx_DoInput()
{
    glo.m_p_input->UpdateLastKey(true);
    glo.m_p_input->Update();
    if (glo.m_p_input->GetLastKey())
    {
        g_b_show_fps = !g_b_show_fps;
       
    }
    
  
    //if (glo.m_p_input->Get)
}


void cdx_DoFrame() 
{ 
    
    glo.UpdateTick();
    glo.m_Screen->GetBack()->Fill(0);                                // Clear the current frame by filling it with black 
    
    frames += 1;                               // Increment the frame count
    
    cdx_DoInput();
    glo.m_p_thing_list->Think();
    glo.m_p_thing_list->ProcessDeleteRequests(); //delete any object that want to be
    glo.m_p_thing_list->ProcessSortRequests(); //sort any objects that want to be
    glo.m_p_thing_list->Draw();
    
   /*
    glo.m_Screen->GetBack()->Lock();               // You must lock the surface before you can use it
    for (int i=0; i < 500; i++)
    {
          glo.m_Screen->GetBack()->PutPixel(random(500),random(500), RGB(random(256), random(256), random(256))); // Do the actual drawing to the screen 
    }
    glo.m_Screen->GetBack()->UnLock();                         // You must unlock it when you are done 
     */
  
   if (g_b_show_fps)
   {
   
    // TODO: Add code to draw your objects during each frame 
       char str[256]; 
    sprintf(str, "FPS: %.2f", glo.m_f_fps);        // Write formatted data to a string. 
    glo.m_Screen->GetBack()->GetDC(); 
    glo.m_Screen->GetBack()->SetFont(); 
    glo.m_Screen->GetBack()->TextXY(5, 5, 255, str); // TextXY(x, y, color, string)
    glo.m_Screen->GetBack()->ReleaseDC();
   } 
    glo.m_Screen->Flip(false,false,false);                           // Flip the back buffer to the front 
}



static long PASCAL WinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int xPos,yPos;
    
    switch(message)
    {
    case WM_KEYDOWN:               // If the user pressed a key
        switch(wParam)
        {          // Use a switch() the find out with key
        case VK_ESCAPE:     // if Escape is pressed, send the message to close the application 
           
            if (glo.p_logic->GetGameMode() != C_MODE_PAUSE)
            {
                //let's just quit out to the title screen.
                glo.p_logic->ResetWholeGame();
            } else
            {
                
                
                SendMessage(hWnd, WM_CLOSE, 0, 0); 
            }
            break; 
        }
        return 0;
        
        case WM_LBUTTONDOWN: 
            //left click
            CMessage mes;
            mes.m_b_hit = false;
            glo.m_p_thing_list->SendMessage(C_MESSAGE_LEFT_CLICK, &mes); //sort any objects that want to be
           
            if (glo.p_logic->GetGameMode() == C_MODE_PLAY)
            {
            

            if (mes.m_b_hit == false)
            {
                
                if (glo.p_logic->GetMud() > 0)
                {
                   
                    //we didn't actually hit or grab anything.  Let's play our sound effect and show a graphic
                    g_sound_player.Play(C_SOUND_SPLAT);
                    //add a mudball graphic
                    CThingSprite *p_sprite = new CThingSprite();
                    glo.m_p_thing_list->AddThing(p_sprite);
                    p_sprite->SetImage("mud_splat.bmp", true);
                    p_sprite->SetPosition(glo.p_mouse->GetX(), glo.p_mouse->GetY());
                    p_sprite->SetKillTimer(20000);
                } else
                {
                    //don't have any mudballs
                }
                
                //either way remove a mudball (if it's already 0 its ok)
                
                glo.p_logic->ModMud(-1);
            }
            }
            
            
            //   CDXLOG("MOUSE!");
             return 0;
            
        case WM_MOUSEMOVE:
            
            xPos = (int) LOWORD(lParam);    // horizontal position
            yPos = (int) HIWORD(lParam);    // vertical position  
           
             if (glo.p_mouse) glo.p_mouse->SetPosition(xPos, yPos);
        
            break;
            
        case WM_CLOSE: cdx_DeInit();    // We recieved a close app message, so deintialize our stuff
        case WM_DESTROY: PostQuitMessage(0); 
            
            return 0;
            
        default: return DefWindowProc(hWnd, message, wParam, lParam); 
            // If we can't use any of these messages then pass them along
    }
return 0;
}


static BOOL InitApp(int nCmdShow) 
{ 
    
    WNDCLASS WndClass;                                 // Create the window object
    WndClass.style = CS_HREDRAW | CS_VREDRAW;          // Tell windows to send a paint message 
    //   when the window is resized
    WndClass.lpfnWndProc = WinProc;                    // Sets the name of the WinProc function, can be changed, don't
    WndClass.cbClsExtra = 0; 
    WndClass.cbWndExtra = 0;
    WndClass.hInstance = glo.m_hInst;                      // Send it our handle instance
    WndClass.hIcon = LoadIcon(glo.m_hInst, "APPICON");     // Sets the icon in the corner of out window
    WndClass.hCursor = LoadCursor(0, IDC_ARROW);       // Sets the cursor to a standard windows arrow
    WndClass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);   // Sets the windows background as black
    WndClass.lpszMenuName = 0;                         // You would load a menu here, but we don't have one
    WndClass.lpszClassName = szClassName;              // Send it our class name
    RegisterClass(&WndClass);                          // Registers the class with windows
    
    glo.m_hWnd = CreateWindowEx(         // This creates the window but it is still not shown 
        WS_EX_TOPMOST, 
        szClassName, 
        szAppName, 
        WS_OVERLAPPED | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU,   // Set window options
        0, 
        0, 
        800,       // Set window width 
        600,       // Set window height 
        NULL, 
        NULL, 
        glo.m_hInst,
        NULL); 
    if(!glo.m_hWnd) return FALSE;           // If the window creation failed, return FALSE
    ShowWindow(glo.m_hWnd, nCmdShow);    // Show the window on the screen 
    UpdateWindow(glo.m_hWnd);          // Show the window on the screen
    return TRUE;
    
} 


int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow) 
{
    
    MSG msg; 
    
    glo.m_hInst = hInstance;       // save the app instance
    
    if(!InitApp(nCmdShow)) return FALSE; 
    if(!cdx_Init()) {                   // See if the initializing failed, if so then quit
        PostQuitMessage(0); 
        return FALSE;
    } 
    
    // This little section resends all the messages in the message queue,
    // After it is done processing them, it then calls cdx_DoFrame(), our main program loop
    while(1) {
        if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
            if(!GetMessage(&msg, NULL, 0, 0 )) return msg.wParam;
            TranslateMessage(&msg); 
            DispatchMessage(&msg); 
        } else {
            cdx_DoFrame();     // Main program loop
        }
    }
    
} 

